`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:44:59 01/21/2011 
// Design Name: 
// Module Name:    DispCtrl 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dispctrl(
clk,			//master clock on FPGA board
//rst,
//horz_cnt,		//horizontal count
//vert_cnt,		//vertical count
horz_sync,		//horizontal syncronize signal
vert_sync,		//vertical synchronize signal
red_out,		//RED output signal
green_out,		//GREEN output signal
blue_out);		//BLUE output signal

parameter PAL=640;	//pixels/active line
parameter LAF=480;	//lines/active frame
parameter PLD=800; 	//pixel/line divider
parameter LFD=521;	//line/frame divider
parameter HPW=96;	//horizontal sync pulse width (pixels)
parameter HFP=16;	//horizontal sync front porch
parameter VPW=2;	//vertical pulse width
parameter VFP=10;	//vertical sync front porch

input 			clk;//,rst;




output					horz_sync;
output					vert_sync;
output	[2:0]			red_out;
output	[2:0]			green_out;
output	[2:1]			blue_out;

reg						clk25MHz,start;
reg		[2:0]			red_out;
reg		[2:0]			green_out;
reg		[2:1]			blue_out;
reg						horz_sync;
reg						vert_sync;
reg		[9:0]			horz_cnt;
reg		[9:0]			vert_cnt;

//reg      [7:0]       image [0:8100];

integer					int_horz_cnt,i;
integer	 				int_vert_cnt;

always @ (posedge clk)	
	clk25MHz = ~clk25MHz;

/*
always @ (posedge clk25MHz) 
begin
for (i = 0;i <= 8100;i=i+1) 
image[i] = 8'hff;
end
	*/

always @ (posedge clk25MHz) //syncronization
begin

	if (int_horz_cnt==PLD-1) begin
		int_horz_cnt=0;
		
		if (int_vert_cnt==LFD-1) 
			int_vert_cnt=0;
		else 
			int_vert_cnt=int_vert_cnt+1;
	end		
	else
		int_horz_cnt=int_horz_cnt+1;
	
//------------generating horz_sync-active low
	if (int_horz_cnt==PAL-1+HFP) 
		horz_sync=0;
	else if (int_horz_cnt==PAL-1+HFP+HPW)
		horz_sync=1;

//------------generating vert_sync-active low
	if (int_vert_cnt==LAF-1+VFP) 
		vert_sync=0;
	else if (int_vert_cnt==LAF-1+VFP+VPW)
		vert_sync=1;
end


always @ (posedge clk25MHz)
begin
	vert_cnt=int_vert_cnt;
	horz_cnt=int_horz_cnt;
end


always @ (clk25MHz,int_horz_cnt,int_vert_cnt)
begin


	if (int_horz_cnt < PAL && int_vert_cnt < LAF) 

		 
			green_out = 3'b111;
			//red_out = 3'b000;	
			//blue_out = 2'b00;end
		
		
	else
		red_out = 3'b111;
		green_out = 3'b111;
		blue_out = 2'b11;
end

endmodule
